<!DOCTYPE html>
<html>

<head>
  <meta charset='utf-8'>
  <title>Pizza 365 project</title>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container">
    <p class="h3 text-center m-5">Chọn đồ uống</p>
    <div class="form-group">
      <label>Đồ uống:</label>
      <select id="select-drink" class="form-control">
        <option value="none">Chọn đồ uống</option>
      </select>
    </div>
    <button id="show-result" class="btn btn-primary w-25" onclick="onBtnShowResultClick()">Hiển thị</button>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/drinks";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // function xử lý sự kiện load trang/F5
    function onPageLoading() {
      // B1: Thu thập dữ liệu
      // B2: Validate dữ liệu
      // B3: Gọi API lấy danh sách đồ uống
      let vXmlHttpDrinkList = new XMLHttpRequest();
      callApiDrinkList(vXmlHttpDrinkList);
      vXmlHttpDrinkList.onreadystatechange = function() {
        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
          // B4: Xử lý front-end
          insertDrinkListToSelect(vXmlHttpDrinkList);
        }
      }
    }

    // function xử lý sự kiện click button Hiển thị
    function onBtnShowResultClick() {
      console.log("%c Nút Hiển thị được nhấn", "color: blue");
      // B1: Thu thập dữ liệu
      let vDrinkSelected = getDrink();
      // B2: Validate dữ liệu
      let vValidData = checkDrink(vDrinkSelected);
      if (vValidData) {
        // B3: Xử lý front-end
        displayConsoleLog();
      }

    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //mã nguồn để load data về
    function sampleCodeLoadData() {
      var vXmlHttpDrinkList = new XMLHttpRequest();
      vXmlHttpDrinkList.onreadystatechange =
        function () {
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
            console.log(vXmlHttpDrinkList.responseText); //ghi response text ra console.log
          }
        };
      vXmlHttpDrinkList.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      vXmlHttpDrinkList.send();
    }

    // function gọi API lấy danh sách đồ uống
    function callApiDrinkList(paramXmlHttp) {
      paramXmlHttp.open("GET", gBASE_URL, true);
      paramXmlHttp.send();
    }

    // function insert danh sách đồ uống vào thẻ select
    function insertDrinkListToSelect(paramXmlHttp) {
      // chuyển string json sang object
      let vDrinkList = JSON.parse(paramXmlHttp.responseText);
      let vDrinkSelectElement = document.getElementById("select-drink");
      for (let bIndex = 0; bIndex < vDrinkList.length; bIndex ++) {
        let vDrinkOption = document.createElement("option");
        vDrinkSelectElement.appendChild(vDrinkOption);
        vDrinkOption.value = vDrinkList[bIndex].maNuocUong;
        vDrinkOption.text = vDrinkList[bIndex].tenNuocUong;
      }
    }

    // function thu thập dữ liệu
    function getDrink() {
      let vDrinkSelectElement = document.getElementById("select-drink");
      let vDrinkSelected = vDrinkSelectElement.value;
      return vDrinkSelected;
    }

    // function validate dữ liệu
    function checkDrink(paramDrink) {
      if (paramDrink == "none") {
        alert("Vui lòng chọn đồ uống");
        return false;
      }
      return true;
    }

    // function hiển thị value và text của đồ uống ra console
    function displayConsoleLog() {
      let vDrinkSelectElement = document.getElementById("select-drink");
      let vDrinkValue = vDrinkSelectElement.value
      let vDrinkText = vDrinkSelectElement.options[vDrinkSelectElement.selectedIndex].text;
      // hiển thị thông tin
      console.log("Drink Value: " + vDrinkValue);
      console.log("Drink Text: " + vDrinkText);
    }

  </script>
</body>

</html>